/* mkd88 - d88 format blank disk make tool */ 
/* ver.1.1 (2003/07/19) by Nyanonon (nyano@areanine.gr.jp) */
#include <stdio.h>
main(int argc,char *argv[]) {
	int i;			/* loop counter */
	int r;			/* return value */
	char buf[0x02b0];	/* write bufferv(d88 header block size) */
	FILE *fp;		/* file pointer for d88 image file D88 */
	/* parameter & option check */
	if(((argc!=2)&&(argc!=3))||((argc==3)&&((argv[2][0]!='-')||((argv[2][1]!='h')&&(argv[2][1]!='d')&&(argv[2][1]!='s'))||(argv[2][2]!=0x00)))) {
		printf("usage: mkd88 <d88-file> [-h|-d|-s]\n");
	}
	else {
		/* d88 image file make */
		fp=fopen(argv[1],"wb");
		if(fp==NULL) {
			printf("file open error.\n");
		}
		else {
			/* d88 header block generate */
			for(i=0x0000;i<0x001a;i++) {
				buf[i]=0x00;
			}
			/* disk type option */
			if((argc==2)||(argv[2][1]=='h')) {
				buf[0x001b]=0x20;	/* 20:2HD */
			}
			else {
				if(argv[2][1]=='d') {
					buf[0x001b]=0x10;	/* 10:2DD */
				}
				else {
					buf[0x001b]=0x00;	/* 00:2D */
				}
			}
			/* init disk size set */
			buf[0x001c]=0xb0;	/* 0x02b0 */
			buf[0x001d]=0x02;
			/* header & track data table 0x00 clear */
			for(i=0x001e;i<0x02b0;i++) {
				buf[i]=0x00;
			}
			/* d88 header block write */
			r=fwrite(buf,1,0x02b0,fp);
			if(r!=0x02b0) {
				printf("file write error.\n");
				r=fclose(fp);
			}
			else {
				r=fclose(fp);
				if(r!=0) {
					printf("file close error.\n");
				}
			}
		}
	}
}
